#Include "MKFMaker.Inc"
#Include "C:\RadASM\GoAsm\Inc\RadAsm.inc"


ADDINOPT struct
	lpStr			dd ?
	nAnd			dd ?
	nOr				dd ?
ADDINOPT ends

DATA SECTION
	hInstance		DD		0
	lpHandles		DD		0
	lpProcs			DD		0
	lpData			DD		0

	AddinOpt		ADDINOPT <0,0,0>

CODE SECTION

GetOptions:
	mov eax,offset AddinOpt
	ret

DllEntryPoint	FRAME hInst, reason, reserved1
    mov eax,[hInst]
    mov [hInstance], eax
    xor eax, eax
    inc eax
    ret
ENDF

InstallDll	FRAME hWin, fOpt
	uses edx,ecx
	invoke SendMessage, [hWin], AIM_GETHANDLES, 0, 0
	mov	[lpHandles], eax
	invoke SendMessage, [hWin], AIM_GETPROCS, 0, 0
	mov [lpProcs], eax
	invoke SendMessage, [hWin], AIM_GETDATA, 0, 0
	mov [lpData], eax

	mov eax, RAM_MAKEBEGIN | RAM_MAKEDONE
	ret
ENDF

DllProc	FRAME hWin, uMsg, wParam, lParam

	cmp D[uMsg], AIM_MAKEBEGIN
	jnz >.MAKEDONE
		invoke BuildMKF
		;
		mov eax,TRUE
		ret

	.MAKEDONE
	cmp D[uMsg], AIM_MAKEDONE
	jnz >.ExitMsgLoop
		
	.ExitMsgLoop
	xor eax, eax
	ret
ENDF

BuildMKF FRAME
	uses edi,esi,ebx
	LOCAL mkfname[MAX_PATH]		:B
	LOCAL szModule[MAX_PATH]	:B
	LOCAL KeyName[8]			:B
	LOCAL hFile					:D
	LOCAL cbWritten				:D

	mov edi,[lpData]
	mov eax,[edi+ADDINDATA.fProject]
	or eax,eax
	jnz >
		RET
	:
	; Build an MKF file name
	invoke lstrcpy,offset mkfname,[edi+ADDINDATA.lpProject]
	invoke lstrlen,offset mkfname
	lea esi,mkfname
	add esi,eax
	sub esi,4
	mov [esi],".mak"
	
	; Verify that this is a GoAsm project
	mov eax,edi
	add eax,ADDINDATA.szAssembler
	invoke lstrcmpi,"goasm",eax
	jz >
		RET
	:

	; See if there are modules in the project
	invoke GetPrivateProfileString,"Files","1001","",offset szModule,MAX_PATH,[edi+ADDINDATA.lpProject]
	or eax,eax
	jnz >
		RET
	:
	; There are modules so create the MKF file
	invoke DeleteFile,offset mkfname
	invoke CreateFile,offset mkfname,GENERIC_WRITE,NULL,NULL,CREATE_NEW,NULL,NULL
	mov [hFile],eax
	
	; Add the first module (the main obj file)
	invoke GetPrivateProfileString,"MakeFiles","3","",offset szModule,MAX_PATH,[edi+ADDINDATA.lpProject]
	invoke lstrcat,offset szModule,<13,10,0>
	invoke lstrlen,offset szModule
	invoke WriteFile,[hFile],offset szModule,eax,offset cbWritten,NULL

	mov ebx,1001
	.READMODS
	invoke wsprintf,offset KeyName,"%u",ebx
	
	; See if there are modules in the project
	invoke GetPrivateProfileString,"Files",offset KeyName,"",offset szModule,MAX_PATH,[edi+ADDINDATA.lpProject]
	or eax,eax
	jnz >
		invoke CloseHandle,[hFile]
		RET
	:
	invoke StripFilePath,offset szModule,offset szModule
	
	mov eax,".obj"
	invoke ChangeExtension,offset szModule,eax

	invoke lstrcat,offset szModule,<13,10,0>
	invoke lstrlen,offset szModule
	invoke WriteFile,[hFile],offset szModule,eax,offset cbWritten,NULL
	inc ebx
	jmp <.READMODS

	RET
ENDF

ChangeExtension FRAME pszModName,dwNewExtension
	uses edi,ebx
	; This procedure strips the old extension (usually .asm) and
	; replaces it with the supplied extension. The extension is NOT
	;passed as a pointer to a string. Rather is is passed as a DWORD
	; in the form 6A626F2Eh or ".obj". No more than 3 characters are allowed
	; smaller extensions can be used by inserting a 0 ie ".ob" = 00626F2Eh 
	; The loworder byte (2Eh) is ignored and replaced with 2Eh

	invoke lstrlen,[pszModName]
	mov ecx,eax
	mov edi,[pszModName]
	add edi,eax
	mov ebx,edi
	mov al,"."
	std
	repne scasb
	cld
	or ecx,ecx
	jnz >
		mov edi,ebx
	:
	inc edi
	mov eax, [dwNewExtension]
	mov al,2Eh
	mov [edi],eax
	RET
ENDF

StripFilePath FRAME pOut,pszFullName
	uses edi,esi
	LOCAL szTemp[MAX_PATH]	:B
	; This procedure will scan back through a filename to find just the
	; file name part, stripping the path information. pOut and pszFullName
	; can point to the same buffer

	invoke lstrlen,[pszFullName]
	mov ecx,eax
	mov edi,[pszFullName]
	add edi,eax
	mov al,"\"
	std
	repne scasb
	cld
	or ecx,ecx
	jz >
	add edi,2
	:
	invoke lstrcpy,offset szTemp,edi
	invoke lstrcpy,[pOut],offset szTemp
	RET
ENDF
